//+---------------------------------------------------------------------+
//|                                                      Silence.mq4    |
//|                                         Copyright  Trofimov 2009   |
//+---------------------------------------------------------------------+
//|                                                               |
//|                                                                     |
//| :                   |
//|  -   (  )             |
//|  -   ( )                 |
//|      , 2009     |
//+---------------------------------------------------------------------+


#property copyright "Copyright  Trofimov Evgeniy Vitalyevich, 2009"
#property link      "http://TrofimovVBA.narod.ru/"

//----  
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 MidnightBlue
#property indicator_width1 1
#property indicator_color2 Maroon
#property indicator_width2 1
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 50

//----  
extern ENUM_TIMEFRAMES TimeFrame     = PERIOD_CURRENT;// Time frame to use
extern int MyPeriod=12;
extern int BuffSize=96;
extern bool Interpolate   = true;          // Interpolate in multi time frame mode?
bool ReDraw=true; //- ,        
//  ,      ,    () 
double Buff_line1[]; // -  
double Buff_line2[]; // - 
double Aggress[], Volatility[];
string indicatorFileName;
bool   returnBars;
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int init()
  {
//---- x  ,   
   IndicatorBuffers(2);
   IndicatorDigits(2); 
//----   (  )
   SetIndexDrawBegin(0,BuffSize+MyPeriod);
   SetIndexDrawBegin(1,BuffSize+MyPeriod);
//---- x   
   SetIndexBuffer(0,Buff_line1);
   SetIndexBuffer(1,Buff_line2);
//----      
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame==-99;
            TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Silence("+MyPeriod+","+BuffSize+") = ");
   SetIndexLabel(0,"Aggressiveness");
   SetIndexLabel(1,"Volatility");
   ArrayResize(Aggress,BuffSize);
   ArrayResize(Volatility,BuffSize);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
int start() {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { Buff_line1[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != Period())
            {
               #define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MyPeriod,BuffSize,_buff,_y)
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  Buff_line1[i] = _mtfCall(0,y);
                  Buff_line2[i] = _mtfCall(1,y);

                  //
                  //
                  //
                  //
                  //
                  
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                     #define _interpolate(buff,i,k,n) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                     int n,k; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                        for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                        {
                           _interpolate(Buff_line1,i,k,n);
                           _interpolate(Buff_line2,i,k,n);
                        }                           
               }
               return(0);
            }

   static datetime LastTime;
   int RD;
   double MAX,MIN;
   double upPrice,downPrice;
   if(ReDraw) RD=1;
   //  
//----   
//----          
   limit=Bars-counted_bars-1+RD;
   
//---- out of range fix
   if(counted_bars==0) limit-=RD+MyPeriod;
   
//----  
   double B;
//----  
   for(int t=limit-RD; t>-RD; t--) {
      
      //   t
      B=0;
      for(int x=t+MyPeriod-1; x>=t; x--) { 
         if(Close[x]>Open[x]) {
            // 
            B=B+(Close[x]-Close[x+1]);
         }else{
            // 
            B=B+(Close[x+1]-Close[x]);
         }
      }//Next x
      
      //   t
      upPrice=High[iHighest(Symbol(),0,MODE_HIGH,MyPeriod,t)];//  N  
      downPrice=Low[iLowest(Symbol(),0,MODE_LOW,MyPeriod,t)]; //  N  
      
      //   ,    
      if(LastTime!=Time[t+1]){
         for(x=BuffSize-1; x>0; x--) {
            Aggress[x]=Aggress[x-1];
            Volatility[x]=Volatility[x-1];
         }//Next x
         LastTime=Time[t+1];
      }
      //  
      
      // 
      Aggress[0]=B/Point/MyPeriod;
      MAX=Aggress[ArrayMaximum(Aggress)];
      MIN=Aggress[ArrayMinimum(Aggress)];
      Buff_line1[t]=(MAX,MIN,100,0,Aggress[0]);
      if(!ReDraw && t==1) Buff_line1[0]=Buff_line1[1];
      //  
      
      // 
      Volatility[0]=(upPrice-downPrice)/Point/MyPeriod;
      MAX=Volatility[ArrayMaximum(Volatility)];
      MIN=Volatility[ArrayMinimum(Volatility)];
      Buff_line2[t]=(MAX,MIN,100,0,Volatility[0]);
      if(!ReDraw && t==1) Buff_line2[0]=Buff_line2[1];
      //  
      
   }//Next t
   return(0);
}
//+------------------------------------------------------------------+
double (double a,double b,double c,double d,double X) {
//a; X; b -   , c; d; -    .
    if(b - a == 0)
        return(10000000); //
    else
        return(d - (b - X) * (d - c) / (b - a));
}//
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
